ESC_READ_DEVICE_STATUS = 0x00 
# ESC_READ_DEVICE_WARNING = 0x01

ESC_READ_VOLTAGE1 = 0x05 # range -2500 ~ +2500 V
ESC_READ_CURRENT1 = 0x06  # range 0 ~ 10000 mA
ESC_READ_VOLTAGE2 = 0x07 # range -2500 ~ +2500 V
ESC_READ_CURRENT2 = 0x08 # range 0 ~ 10000 mA

ESC_READ_VBIA = 0x09 # range 0 ~ 1250
ESC_READ_VCS = 0x0A # range 0.000 ~ 3.300 V
ESC_READ_ICS = 0x0B # range 0.000 ~ 3.300 V
ESC_READ_CAP = 0x0C # range 0 ~ 15000
ESC_READ_IO_LEAK1 = 0x0D # range 0 ~ 22.6
ESC_READ_IO_LEAK2 = 0x0E # range 0 ~ 22.6

# WRITE 후 READ DATA
ESC_READ_SET_VOLTAGE1 = 0x10 # range -2500 ~ +2500 V
ESC_READ_SET_CURRENT1 = 0x11  # range 0 ~ 10000 mA
ESC_READ_SET_VOLTAGE2 = 0x12 # range -2500 ~ +2500 V
ESC_READ_SET_CURRENT2 = 0x13 # range 0 ~ 10000 mA

ESC_READ_SET_LEAK_FAULT_LEVEL = 0x14 
ESC_READ_SET_RO_MIN_FAULT = 0x15 
ESC_READ_SET_RAMP_UPTIME = 0x16 
ESC_READ_SET_RAM_DOWNTIME = 0x17 
ESC_READ_SET_AUTO_TOGGLE_MODE = 0x18
ESC_READ_SET_AUTO_TOGGLE_COUNT = 0x19
ESC_READ_SET_SLOPE = 0x1A
ESC_READ_SET_COEFF = 0x1B
ESC_READ_SET_ONOFF_SELECTION = 0x1D
ESC_READ_SET_ARC_DELAY = 0x1F
ESC_READ_SET_ARC_RATE = 0x20
ESC_READ_SET_TOGGLE = 0x21 
ESC_READ_SET_ARC_CONTROL = 0x22
ESC_READ_SET_OCP_CONTROL = 0x23
ESC_READ_SET_TARGET_CAPACITOR = 0x24 
ESC_READ_SET_CAP_DEVIATION = 0x25


# WRITE_RUN_ADDRESS = 0x00
RUN_VALUE = 2
STOP_VALUE = 0

ESC_WRITE_BIT_POWER_ON = 0x00

ESC_WRITE_VOLTAGE1 = 0x01 # range -2500 ~ +2500 V
ESC_WRITE_CURRENT1 = 0x02  # range 0 ~ 10000 mA
ESC_WRITE_VOLTAGE2 = 0x03 # range -2500 ~ +2500 V
ESC_WRITE_CURRENT2 = 0x04 # range 0 ~ 10000 mA

ESC_WRITE_LEAK_LEVEL = 0x05 
ESC_WRITE_RO_MIN_FAULT = 0x06 
ESC_WRITE_RAMP_UP_TIME = 0x07 
ESC_WRITE_RAMP_DOWN_TIME = 0x08 
ESC_WRITE_TOGGLE_MODE = 0x09 
ESC_WRITE_TOGGLE_COUNT = 0x0A 

ESC_WRITE_SET_SLOPE = 0x0B 
ESC_WRITE_SET_COEFF = 0x0C
ESC_WRITE_ONOFF_SELECTION = 0x0E 
ESC_WRITE_LOCAL_ADDRESS = 0x0F 
ESC_WRITE_ARC_DELAY = 0x10 
ESC_WRITE_ARC_RATE = 0x11 
ESC_WRITE_TOGGLE = 0x12 
ESC_WRITE_ARC_CONTROL = 0x13 
ESC_WRITE_OCP_CONTROL = 0x14 
ESC_WRITE_TARGET_CAPACITOR = 0x15 
ESC_WRITE_CAP_DEVIATION = 0x16 

# DEVELOPER MODE need password 
ESC_DEV_PASSWORD = 0x7cf

ESC_DEV_COMM_MODE = 0x7d0   # 0 ~ 2

ESC_DEV_CAP_OFFSET = 0x7d1  # -999 ~ 999

ESC_DEV_VO1_GAIN = 0x7d2    # -999 ~ 999
ESC_DEV_IO1_GAIN = 0x7d3    # -999 ~ 999
ESC_DEV_VO1_OFFSET = 0x7d4  # -999 ~ 999
ESC_DEV_IO1_OFFSET = 0x7d5  # -999 ~ 999

ESC_DEV_VO2_GAIN = 0x7d6    # -999 ~ 999
ESC_DEV_IO2_GAIN = 0x7d7    # -999 ~ 999
ESC_DEV_VO2_OFFSET = 0x7d8  # -999 ~ 999
ESC_DEV_IO2_OFFSET = 0x7d9  # -999 ~ 999

ESC_DEV_VCS_GAIN = 0x7da    # 0 ~ 1200
ESC_DEV_ICS_GAIN = 0x7db    # 0 ~ 1200
ESC_DEV_ZCS1_GAIN = 0x7dc   # 0 ~ 999
ESC_DEV_ZCS2_GAIN = 0x7dd   # 0 ~ 999
ESC_DEV_ZCS3_GAIN = 0x7de   # 0 ~ 999

ESC_DEV_AOIO1_GAIN = 0x7df  # -999 ~ 999
ESC_DEV_AOIO2_GAIN = 0x7e0  # -999 ~ 999
ESC_DEV_VBIAS_GAIN = 0x7e1  # -999 ~ 999
ESC_DEV_VBIAS_OFFSET = 0x7e2  # -999 ~ 999
ESC_DEV_OVP_CONTROL = 0x7e3   # 0 or 1 
ESC_DEV_IROVP_CONTROL = 0x7e4   # 0 or 1 
ESC_DEV_TEST_MODE = 0x7e5   # 0 or 1 

ESC_DEV_MODEL = 0x7e6       # 15250
ESC_DEV_VERSION = 0x7e7     # 550
ESC_DEV_LEAK1_OFFSET = 0x7e8 # -999 ~ 999
ESC_DEV_LEAK2_OFFSET = 0x7e9 # -999 ~ 999
ESC_DEV_LEAK1_GAIN = 0x7ea # -999 ~ 999
ESC_DEV_LEAK2_GAIN = 0x7eb # -999 ~ 999

FORWARD = 0 
REVERSE = 1 
BIT_FAULT_CLEAR = 0x04

OFF = 0 
ON = 1
FAULT = 1
NORMAL = 0

UNIT = 0x1